#ifndef CLUSTERING_H
#define CLUSTERING_H

// #include "matrix.h"
// #include "pattern.h"

typedef int *PARTITION;

typedef struct {
   PATTERN   Codebook;
   PARTITION P;
   int	     *ClusterSize;
   int	     NumTrainingVectors;
} CLUSTERING_TYPE;
typedef CLUSTERING_TYPE* CLUSTERING;

/* typedef struct {
   int	  MaxIter;
   int	  NumberOfInitialSolutions;
   double  MinChange;
} CL_PARAMS_TYPE;
typedef CL_PARAMS_TYPE* CL_PARAMS; */

/* A few basic macros ---------------------------------------- */
#define GetCodebook(CL)	 	((CL)->Codebook)
#define BookSize(CL)		((CL)->Codebook->NumberOfVectors)
#define BookDim(CL)		((CL)->Codebook->Dimensionality)
#define GetPartition(CL) 	((CL)->Partition)
#define ClusterSize(CL, Index)	((CL)->ClusterSize[Index-1])
#define NumTrainingVectors(CL)	((CL)->NumTrainingVectors)

/* I/O ------------------------------------------------------- */
CLUSTERING NewClustering(int CodebookSize, PATTERN TrainingData);
void DeleteClustering(CLUSTERING CL);
void CopyClustering(CLUSTERING To, CLUSTERING From);
void PrintCodebook(FILE* f, CLUSTERING CL);
void PrintPartition(FILE* f, CLUSTERING CL);
PATTERN Clustering2Pattern(CLUSTERING CL);

/* Clustering ------------------------------------------------ */
void  InitClustering(CLUSTERING CL, PATTERN TrainingData);
double EvaluateClustering(CLUSTERING CL, PATTERN TrainingData);
void  IterateGLA(CLUSTERING CL, PATTERN TrainingData, Parameters *parap);
void  RGLA(CLUSTERING CL, PATTERN TrainingData, Parameters *parap); 
 
#endif /* CLUSTERING_H */
