/* cmdline.h */

/* File autogenerated by gengetopt version 2.6  */

#ifndef _cmdline_h
#define _cmdline_h

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

/* Don't define PACKAGE and VERSION if we use automake.  */
#if defined PACKAGE
#  undef PACKAGE
#endif
#define PACKAGE "speakerid family (adduser, identifyuser and removeuser)"
#if defined VERSION
#  undef VERSION
#endif
#define VERSION "1.0"

struct gengetopt_args_info {
  char * input_arg;	/* Audio inputfile.  */
  char * speakerdb_arg;	/* Speaker databasefile.  */
  char * modelpath_arg;	/* Path to speakermode files.  */
  char * featurefile_arg;	/* Feature outputfile.  */
  int model_size_arg;	/* Model size (clusters per speaker) (default=64).  */
  int max_iterations_arg;	/* Stopping criterion, Max iterations (default=100).  */
  double stop_threshold_arg;	/* Stopping criterion, Min error, threshold (default=0).  */
  int initial_solutions_arg;	/* Number of initial solutions (RGLA) (default=5).  */
  int matching_function_arg;	/* Which matching function to use...  (default=1).  */
  int using_cb_flag;	/* Create codebook also for matching (default=on).  */
  int maxiter_arg;	/* Max iterations for codebook generation (default=5).  */
  int cb_size_arg;	/* Intermediate codebook size (default=0).  */
  int decision_function_arg;	/* Which decision function to use... (default=1).  */
  int nbest_arg;	/* Number of best matches (default=0).  */
  int confidence_measure_arg;	/* Which confidence measure to use... (default=1).  */
  int win_length_arg;	/* window length in ms (default=30).  */
  int win_shift_ms_arg;	/* window shift in ms (default=10).  */
  int remove_sil_flag;	/* remove silence (default=off).  */
  double sil_thr_arg;	/* silence threshold coeff (default=1).  */
  int remove_dc_offset_flag;	/* remove DC-offcet (default=off).  */
  int win_function_type_arg;	/* Which window function to use ... (default=1).  */
  double high_emph_coeff_arg;	/* High emphasis coefficient (default=1).  */
  int feat_type_arg;	/* Feature-type: MFCC ... (default=1).  */
  int num_mel_filters_arg;	/* Number of mel-filters (default=0).  */
  int include_delta_flag;	/* Include delta coeff (default=off).  */
  int include_delta_delta_flag;	/* Include delta delta coeff (default=off).  */
  int include_0th_coeff_flag;	/* include 0th coefficient (default=off).  */
  int MFCC_ord_arg;	/* MFCC-order =~ dimension of result vector (default=12).  */
  int lifter_type_arg;	/* Lifter function type (default=1).  */
  int absolute_magnitude_flag;	/* Absolute magnitude (default=on).  */
  int id_arg;	/* Unique speaker ID.  */
  char * name_arg;	/* Speaker name.  */
  int gender_arg;	/* Speakers gender.  */
  int age_arg;	/* Speakers age.  */
  int dialect_arg;	/* Speakers dialect.  */

  int help_given ;	/* Whether help was given.  */
  int version_given ;	/* Whether version was given.  */
  int input_given ;	/* Whether input was given.  */
  int speakerdb_given ;	/* Whether speakerdb was given.  */
  int modelpath_given ;	/* Whether modelpath was given.  */
  int featurefile_given ;	/* Whether featurefile was given.  */
  int model_size_given ;	/* Whether model_size was given.  */
  int max_iterations_given ;	/* Whether max_iterations was given.  */
  int stop_threshold_given ;	/* Whether stop_threshold was given.  */
  int initial_solutions_given ;	/* Whether initial_solutions was given.  */
  int matching_function_given ;	/* Whether matching_function was given.  */
  int using_cb_given ;	/* Whether using_cb was given.  */
  int maxiter_given ;	/* Whether maxiter was given.  */
  int cb_size_given ;	/* Whether cb_size was given.  */
  int decision_function_given ;	/* Whether decision_function was given.  */
  int nbest_given ;	/* Whether nbest was given.  */
  int confidence_measure_given ;	/* Whether confidence_measure was given.  */
  int win_length_given ;	/* Whether win_length was given.  */
  int win_shift_ms_given ;	/* Whether win_shift_ms was given.  */
  int remove_sil_given ;	/* Whether remove_sil was given.  */
  int sil_thr_given ;	/* Whether sil_thr was given.  */
  int remove_dc_offset_given ;	/* Whether remove_dc_offset was given.  */
  int win_function_type_given ;	/* Whether win_function_type was given.  */
  int high_emph_coeff_given ;	/* Whether high_emph_coeff was given.  */
  int feat_type_given ;	/* Whether feat_type was given.  */
  int num_mel_filters_given ;	/* Whether num_mel_filters was given.  */
  int include_delta_given ;	/* Whether include_delta was given.  */
  int include_delta_delta_given ;	/* Whether include_delta_delta was given.  */
  int include_0th_coeff_given ;	/* Whether include_0th_coeff was given.  */
  int MFCC_ord_given ;	/* Whether MFCC_ord was given.  */
  int lifter_type_given ;	/* Whether lifter_type was given.  */
  int absolute_magnitude_given ;	/* Whether absolute_magnitude was given.  */
  int id_given ;	/* Whether id was given.  */
  int name_given ;	/* Whether name was given.  */
  int gender_given ;	/* Whether gender was given.  */
  int age_given ;	/* Whether age was given.  */
  int dialect_given ;	/* Whether dialect was given.  */
} ;

int cmdline_parser (int argc, char * const *argv, struct gengetopt_args_info *args_info);

void cmdline_parser_print_help(void);
void cmdline_parser_print_version(void);

#ifdef __cplusplus
}
#endif /* __cplusplus */
#endif /* _cmdline_h */
