#include "matrix.h"
#include "misc.h"
#include "distortion.h"

static VECTOR_DISTORTION VectorDistortionType = vdEuclidean;

void InitVectorDistortion(VECTOR_DISTORTION Vd) {
             
        VectorDistortionType = Vd;
}
             
double VectorDistortion(MATRIX x, MATRIX y) {
   
   double Dist; 
 
   switch(VectorDistortionType) {
        case vdEuclidean:
             Dist = VectorDistance(x, y, 2);
             break;
        case vdManhattan:
             Dist = VectorDistance(x, y, 1);
             break;
        case vdMaximum:
	  //             Dist = VectorMaxDistance(x, y);
             break;
        default:
             SegFault("ERROR [VectorDistortion] : unknown distortion type\n");
             break;
   }
 
   return Dist;
}
