/* --------------------------------------------------------------------*/
/*  frame.h       Ville Hautamki, 2002                                */
/*                Teemu Kilpelinen 20.10.2000			       */
/*   								       */
/*								       */
/*                                                                     */  
/* --------------------------------------------------------------------*/


#ifndef FRAME_H
#define FRAME_H 

typedef struct Frame Frame;

/* Original struct FRAME_INFORMATION by Teemu Kilpelinen 2000-2001. 
 * Members of that struct are now included in current 
 * Frame struct. 
 */

struct Frame {
  int length;             /* Length of frame in samples pow two*/ 
  int win_shift_samples;  /* Length of window (frame) shifting in samples */
  int begin;              /* Index of frame's starting point */   
  int samples_per_frame;  /* Length of frame (in samples) */            
  double *win_coeff;      /* Window coefficients */
  double *frame;          /* Current frame */
};


Frame *init_frame(Signal *sigptr, Parameters *parap);
void free_frame(Frame *ptr);
void WindowCoefficients(Frame *frptr, int window_type);
void MakeFrame(Signal *sigptr, Frame *frptr);
void print_frame(Frame *frptr, FILE *foobar);
#endif 
