/* list.h by Ville Hautamki <villeh@cs.joensuu.fi>, 2001
   All sources are under GPL */

#ifndef LIST_H
#define LIST_H

typedef struct List List;
typedef struct Element Element;
typedef struct Iterator Iterator;

struct List {
  int total_elements;
  Element *top;
};

struct Element {
  int id;            // Element id number 
  char *path;
  char *name;
  int gender;
  int age;
  int dialect;
  Element *next;
  Element *prev;
};

struct Iterator {
  Element *curele;
};

List *create_list(void);
void insert_element(List *listp, Element *elep);
void free_list(List *listp);
void free_element(List *listp, Element *elep);
Iterator *iterate_start(void);
Element *iterate_element(List *listp, Iterator *itep);
Element *find_element(List *listp, int id);
Element *get_element(List *listp);
void print_list(List *listp);
#endif
