/* --------------------------------------------------------------------*/
/*  MEL-FUNCTIONS.H     Teemu Kilpelinen 20.10.2000		       */
/*   								       */
/* --------------------------------------------------------------------*/


#ifndef MEL_FUNCTIONS_H
#define MEL_FUNCTIONS_H

//#include "s2t_defs.h"

typedef struct Filter Filter;
typedef struct Filterbank Filterbank;

struct Filter {
  int filter_begin;
  int filter_end;
  double *coeffs;
};

struct Filterbank {
  int num_mel_filters;
  Filter *filters;
};

Filterbank *CreateFilterBank(int count_of_filters, int length, 
			     int sampling_rate); 
Filter *GetFilter(Filterbank *filter_bank, int filter_index);  
double FilterOutput(Filter *filter, double *frame);
int NumberOfMelFilters(int sampling_rate);
void ComputeLogFilteredSpectrum(double *frame, double *log_filtered_spectrum, 
				Filterbank *filter_bank, Parameters *parap);
void free_filterbank(Filterbank *filterbank);
int Hz2Index(double frequency, int sampling_rate, int frame_length);
double Hz2Mel(double Hz_frequency);

#endif 
