/* --------------------------------------------------------------------*/
/*---------------------------------------------------------------------*/
/*  signal.h by Ville Hautamki <villeh@cs.joensuu.fi>, 2002           */
/* --------------------------------------------------------------------*/

#ifndef SIGNAL_H
#define SIGNAL_H

typedef struct Signal Signal;

struct Signal {
  int num_samples;  // Number of samples
  int num_ch;       // Number of channels
  int srate;        // Sample rate
  int bps;          // Bits per sample
  double *signal_buffer;  // Signal buffer
};

Signal *create_signal(int num_samples);
void free_signal(Signal *ptr);
void print_signal(Signal *ptr, FILE *filep);
double get_sample(Signal *ptr, int ith_sample); 
void put_sample(Signal *ptr, int ith_sample, double value); 
void set_srate(Signal *ptr, int srate);
int get_srate(Signal *ptr); 
void set_bps(Signal *ptr, int bps);
int get_bps(Signal *ptr); 
int get_nsamples(Signal *ptr);
void set_nch(Signal *ptr, int num_ch);

#endif 
